﻿; http://ahkscript.org/germans/forums/viewtopic.php?t=6803
; Klavier Hero by Bentschi
; Modified version to support AHK v1.1 x32 Unicode and US keyboard
; Modified again by Drugwash to use scan codes and proper data types [v1.1]

#NoEnv
#SingleInstance force
#WinActivateForce
SetTitleMatchMode, 2
SetBatchLines, -1
SetWinDelay, -1
SetControlDelay, -1
SetKeyDelay, -1, -1
SetMouseDelay, -1
ListLines, Off
SetFormat, Integer, D
SetWorkingDir, %A_ScriptDir%
DetectHiddenWindows, On
AW := A_IsUnicode ? "W" : "A", A_CharSize := A_IsUnicode ? 2 : 1

Vol := 85			; [%] Initial volume
Device := 0		; 0=Default
Instrument := 1	; [1-128] Default instrument
Channel := 1		; [1-4] Default channel
Oktav := 1			; [-2-4] Default octave

KbdW := 400		; [px] Initial keyboard width
KbdH := 80		; [px] Initial keyboard height
DrawMode := 1	; [0-1] Initial drawing mode (1=OpenGL)

Instruments =
(Join|
1 Acoustic Grand Piano
2 Bright Piano
3 Electric Grand Piano
4 Honky-tonk piano
5 Electric Piano 1
6 Electric Piano 2
7 Harpsichord
8 Clav
9 Celesta
10 Glockenspiel
11 Music Box
12 Vibraphone
13 Marimba
14 Xylophone
15 Tubular Bells
16 Dulcimer
17 Drawbar Organ
18 Percussive Organ
19 Rock Organ
20 Church Organ
21 Reed Organ
22 Accordian
23 Harmonica
24 Tango Accordian
25 Nylon String Guitar
26 Steel String Guitar
27 Jazz Guitar
28 Clean Electric Guitar
29 Muted Electric Guitar
30 Overdrive Guitar
31 Distortion Guitar
32 Guitar Harmonics
33 Acoustic Bass
34 Fingered Bass
35 Picked Bass
36 Fretless Bass
37 Slap Bass 1
38 Slap Bass 2
39 Synth Bass 1
40 Synth Bass 2
41 Violin
42 Viola
43 Cello
44 Contrabass
45 Tremolo Strings
46 Pizzicato Strings
47 Orchestral Harp
48 Timpani
49 String Ensemble 1
50 String Ensemble 2
51 Synth Strings 1
52 Synth Strings 2
53 Choir Ahh
54 Choir Oohh
55 Synth Voice
56 Orchestral Hit
57 Trumpet
58 Trombone
59 Tuba
60 Muted Trumpet
61 French Horn
62 Brass Section
63 Synth Brass 1
64 Synth Brass 2
65 Soprano Sax
66 Alto Sax
67 Tenor Sax
68 Baritone Sax
69 Oboe
70 English Horn
71 Bassoon
72 Clarinet
73 Piccolo
74 Flute
75 Recorder
76 Pan Flute
77 Blown Bottle
78 Shakuhachi
79 Whistle
80 Ocarina
81 Square Wav
82 Sawtooth Wav
83 Caliope
84 Chiff
85 Charang
86 Voice
87 Fifth's
88 Bass&Lead
89 New Age
90 Warm
91 Polysynth
92 Choir
93 Bowed
94 Metallic
95 Halo
96 Sweep
97 FX Rain
98 FX Soundtrack
99 FX Crystal
100 FX Atmosphere
101 FX Brightness
102 FX Goblins
103 FX Echo Drops
104 FX Star Theme
105 Sitar
106 Banjo
107 Shamisen
108 Koto
109 Kalimba
110 Bagpipe
111 Fiddle
112 Shanai
113 Tinkle Bell
114 Agogo
115 Steel Drums
116 Woodblock
117 Taiko Drum
118 Melodic Tom
119 Synth Drum
120 Reverse Cymbal
121 Guitar Fret Noise
122 Breath Noise
123 Seashore
124 Bird Tweet
125 Telephone Ring
126 Helicopter
127 Applause
128 Gunshot
)
WM_KEYDOWN := 0x100, WM_KEYUP := 0x101
WM_LBUTTONDOWN := 0x201, WM_LBUTTONUP := 0x202

charL := Asc("A"), charH := Asc("Z"), charR := charH - charL + 1
HotkeysLine1 := "56,1E,2C,1F,2D,20,2E,2F,22,30,23,31,32,25,33,26,34,27,35"
HotkeysLine2 := "10,03,11,04,12,13,06,14,07,15,08,16,17,0A,18,0B,19,1A,0D,1B"

Hotkeys := HotkeysLine1 "," HotkeysLine2
Loop, Parse, Hotkeys, CSV
	{
	sc := "0x" A_Loopfield, sc+=0
	Key%sc% := A_Index
	MKey%A_Index% := sc
	NumKeys := A_Index
	}

hWinMM := DllCall("kernel32\LoadLibrary" AW, "Str", "Winmm.dll", "Ptr")
NumDevs := DllCall("Winmm\midiOutGetNumDevs"), sz := 20+32*A_CharSize
Loop, % NumDevs
	{
	VarSetCapacity(DevCaps, sz, 0)
	DllCall("Winmm\midiOutGetDevCaps" AW, "UInt", A_Index-1, "Ptr", &DevCaps, "UInt", sz)
	Name := StrGet(&DevCaps+8)
	DevName%A_Index% := Name
	DevNames .= Name "|"
	}
StringTrimRight, DevNames, DevNames, 1
VarSetCapacity(DevCaps, 0), VarSetCapacity(Name, 0)
Volume := Round(Vol*127/100)

Gui, Add, DDL, x-200 y-200 w0 h0 vFocusButton
Gui, Add, Text, x10 y10 cBlue, Instrument:
Gui, Add, ListBox, xp y+3 w150 h300 +AltSubmit gChooseInstr vList, % Instruments
GuiControl, Choose, List, % Instrument
Gui, Add, Text, x+10 y10 cBlue, Device:
Gui, Add, DDL, xp y+3 w200 +AltSubmit vDev gChooseDev, % DevNames
GuiControl, Choose, Dev, % Device+1
Gui, Add, Text, xp y+15 cBlue vVolLabel, Volume: %Vol% `%%A_Space%%A_Space%
Gui, Add, Slider, xp y+3 w200 vVol gChooseVol +0x100 Range0-100, % Vol
Gui, Add, Text, xp y+5 cBlue, Channel:
Gui, Add, DDL, xp y+3 w200 +Altsubmit vChannel gChooseChannel
	, Channel 1||Channel 2|Channel 3|Channel 4
Gui, Add, Text, xp y+15 cBlue, Virtual keyboard:
Gui, Add, DDL, xp y+3 w200 +AltSubmit vDrawMode gChooseDrawMode, [Hidden]|OpenGL
Gui, Add, Text, xp y+15 cBlue, Octave:
Gui, Add, Edit, xp y+3 w200
Gui, Add, UpDown, Range-2-4 vOktav gChooseOktav, % Oktav
GuiControl, Choose, DrawMode, % DrawMode+1
Gui +LastFound
hWnd := WinExist()
Gui, Show,, Klavier Hero 2010

GoSub, InitMidi
OnExit, ExitSub
OnMessage(WM_KEYDOWN, "PlayTone", 10)
OnMessage(WM_KEYUP, "ReleaseTone", 10)
OnMessage(WM_LBUTTONDOWN, "MouseClick")
OnMessage(WM_LBUTTONUP, "MouseRelease")
GoSub, EnableDraw
Return

ChooseDev:
GuiControlGet, Device,, Dev
Device--
Return

ChooseVol:
GuiControlGet, Vol,, Vol
Volume := Round(Vol*127/100)
GuiControl,, VolLabel, Volume: %Vol% `%
Return

ChooseChannel:
GuiControlGet, Channel
Return

ChooseOktav:
GuiControlGet, Oktav
Return

InitMidi:
If (Device > NumDevs)
  Device := 0
If (hMidiOut)
  GoSub, FreeMidi
midiOutShortMsg := DllCall("kernel32\GetProcAddress", "Ptr", hWinMM, "AStr", "midiOutShortMsg", "Ptr")
VarSetCapacity(hMidiOut, A_PtrSize, 0)
DllCall("Winmm\midiOutOpen", "PtrP", hMidiOut, "UInt", Device, "Ptr", 0, "Ptr", 0, "UInt", 0)
Return

ChooseInstr:
GuiControlGet, Instrument,, List
Instrument--
Return

FreeMidi:
DllCall("Winmm\midiOutReset", "Ptr", hMidiOut)
DllCall("Winmm\midiOutClose", "Ptr", hMidiOut)
Return

GuiClose:
ExitSub:
Gui, Hide
GoSub, DisableDraw
GoSub, FreeMidi
DllCall("FreeLibrary", "Ptr", hWinMM)
ExitApp

PlayTone(wParam, lParam)
{
Global
Local cTone, sc
sc := (lParam>>16)&0xFF
If (Key%sc% && !Key%sc%down)
	{
	cTone := (Key%sc% + 52) + ((Oktav - 1) * 12)
	GuiControl, Focus, Focusbutton
	DllCall(midiOutShortMsg, "Ptr", hMidiOut, "UInt", (Instrument<<8) + Channel+191)
	DllCall(midiOutShortMsg, "Ptr", hMidiOut, "UInt", (Volume<<16) + (cTone<<8) + Channel+143)
	KeyIndex := Key%sc%
	Key%sc%down := KeyI%KeyIndex%down := 1
	}
Return
}

ReleaseTone(wParam, lParam)
{
Global
Local cTone, sc
sc := (lParam>>16)&0xFF
If Key%sc%down
	{
	KeyIndex := Key%sc%
	Key%sc%down := KeyI%KeyIndex%down := 0
	cTone := (Key%sc% + 52) + ((Oktav - 1) * 12)
	DllCall(midiOutShortMsg, "Ptr", hMidiOut, "UInt", (Volume<<16) + (cTone<<8) + Channel+127)
	}
Return
}

MouseClick(wParam, lParam, msg, handle)
{
Global
If (DrawMode && handle=hWnd2)
	{
	MouseClick := 0
	MouseX := (lParam & 0xFFFF) / KbdW * 100
	MouseY := (lParam >> 16) / KbdH * 10
	CalcXPos := KeyWW - (KeyBW / 2)
	Index := 1
	Loop, % NumKeys
		{
		If Index in 2,4,6,9,11
			{
			If (MouseX < (CalcXPos + KeyBW)) && (MouseX > CalcXPos) && (MouseY < 10/4*2.5)
				{
				MouseClick := A_Index
				Break
				}
			CalcXPos := CalcXPos + KeyWW
			}
		If Index in 6,11
			CalcXPos := CalcXPos + KeyWW
		Index++
		If Index > 12
			Index := 1
		}
	If !MouseClick
		{
		CalcXPos := 0
		Index := 1
		Loop, % NumKeys
			{
			If Index in 1,3,5,7,8,10,12
				{
				If (MouseX > CalcXPos) && (MouseX < (CalcXPos + KeyWW))
					{
					MouseClick := A_Index
					Break
					}
				CalcXPos := CalcXPos + KeyWW
				}
			Index++
			If Index > 12
				Index := 1
			}
		}
	PlayTone(0, MKey%MouseClick%<<16)
	}
Return
}

MouseRelease(wParam, lParam, msg, handle)
{
Global
ReleaseTone(0, MKey%MouseClick%<<16)
MouseClick := 0
Return
}

ChooseDrawMode:
GuiControlGet, DrawMode
DrawMode--

EnableDraw:
Gui, 2: +LastFound +Resize -MinimizeBox -MaximizeBox -DPIscale
hWnd2 := WinExist()
If DrawModeInit
  GoSub, DisableDraw
If DrawMode=1
  GoTo, InitOpenGL
Return

2GuiClose:
GuiControl, 1:Choose, DrawMode, 1
DisableDraw:
Gui, 2:Hide
If DrawModeInit
	{
	SetTimer, UpdateOpenGL, Off
	DllCall("opengl32\wglMakeCurrent", "Ptr", 0, "Ptr", 0)
	DllCall("opengl32\wglDeleteContext", "Ptr", hRC)
	DllCall("gdi32\SelectObject", "Ptr", hDC, "Ptr", hOFont)
	DllCall("user32\ReleaseDC", "Ptr", hWnd2, "Ptr", hDC)
	DllCall("gdi32\DeleteObject", "Ptr", hFont)
	DllCall("kernel32\FreeLibrary", "Ptr", hOpenGL)
	DllCall("kernel32\FreeLibrary", "Ptr", hGdi32)
	}
DrawModeInit := 0
Return

2GuiSize:
KbdW := A_GuiWidth, KbdH := A_GuiHeight
Return

InitOpenGL:
DrawModeInit := 1
hOpenGL := DllCall("kernel32\LoadLibrary" AW, "Str", "opengl32.dll", "Ptr")
hGdi32  := DllCall("kernel32\LoadLibrary" AW, "Str", "gdi32.dll", "Ptr")
hDC := DllCall("user32\GetDC", "Ptr", hWnd2, "Ptr")
VarSetCapacity(pfd, 40, 0)	; PIXELFORMATDESCRIPTOR struct
NumPut(40, pfd, 0, "UShort")	; nSize
NumPut(1, pfd, 2, "UShort")		; nVersion
NumPut(0x25, pfd, 4, "UInt")	; PFD_SUPPORT_OPENGL/DRAW_TO_WINDOW/DOUBLEBUFFER
NumPut(0, pfd, 8, "UChar")		; iPixelType PFD_TYPE_RGBA
NumPut(32, pfd, 9, "UChar")		; cColorBits
NumPut(16, pfd, 23, "UChar")	; cDepthBits
NumPut(0, pfd, 26, "UChar")		; iLayerType
PixelFormat := DllCall("gdi32\ChoosePixelFormat", "Ptr", hDC, "Ptr", &pfd)
DllCall("gdi32\SetPixelFormat", "Ptr", hDC, "UInt", PixelFormat, "Ptr", &pfd)
hRC := DllCall("opengl32\wglCreateContext", "Ptr", hDC, "Ptr")
DllCall("opengl32\wglMakeCurrent", "Ptr", hDC, "Ptr", hRC)
SwapBuffers := DllCall("kernel32\GetProcAddress", "Ptr", hGdi32, "AStr", "SwapBuffers", "Ptr")
glClear := DllCall("kernel32\GetProcAddress", "Ptr", hOpenGL, "AStr", "glClear", "Ptr")
glViewport := DllCall("kernel32\GetProcAddress", "Ptr", hOpenGL, "AStr", "glViewport", "Ptr")
glMatrixMode := DllCall("kernel32\GetProcAddress", "Ptr", hOpenGL, "AStr", "glMatrixMode", "Ptr")
glLoadIdentity := DllCall("kernel32\GetProcAddress", "Ptr", hOpenGL, "AStr", "glLoadIdentity", "Ptr")
glOrtho := DllCall("kernel32\GetProcAddress", "Ptr", hOpenGL, "AStr", "glOrtho", "Ptr")
glColor4f := DllCall("kernel32\GetProcAddress", "Ptr", hOpenGL, "AStr", "glColor4f", "Ptr")
glRotatef := DllCall("kernel32\GetProcAddress", "Ptr", hOpenGL, "AStr", "glRotatef", "Ptr")
glScalef := DllCall("kernel32\GetProcAddress", "Ptr", hOpenGL, "AStr", "glScalef", "Ptr")
glTranslatef := DllCall("kernel32\GetProcAddress", "Ptr", hOpenGL, "AStr", "glTranslatef", "Ptr")
glVertex2f := DllCall("kernel32\GetProcAddress", "Ptr", hOpenGL, "AStr", "glVertex2f", "Ptr")
glPushMatrix := DllCall("kernel32\GetProcAddress", "Ptr", hOpenGL, "AStr", "glPushMatrix", "Ptr")
glPopMatrix := DllCall("kernel32\GetProcAddress", "Ptr", hOpenGL, "AStr", "glPopMatrix", "Ptr")
glEnable := DllCall("kernel32\GetProcAddress", "Ptr", hOpenGL, "AStr", "glEnable", "Ptr")
glDisable := DllCall("kernel32\GetProcAddress", "Ptr", hOpenGL, "AStr", "glDisable", "Ptr")
glBegin := DllCall("kernel32\GetProcAddress", "Ptr", hOpenGL, "AStr", "glBegin", "Ptr")
glEnd := DllCall("kernel32\GetProcAddress", "Ptr", hOpenGL, "AStr", "glEnd", "Ptr")
glGenLists := DllCall("kernel32\GetProcAddress", "Ptr", hOpenGL, "AStr", "glGenLists", "Ptr")
glNewList := DllCall("kernel32\GetProcAddress", "Ptr", hOpenGL, "AStr", "glNewList", "Ptr")
glCallList := DllCall("kernel32\GetProcAddress", "Ptr", hOpenGL, "AStr", "glCallList", "Ptr")
glEndList := DllCall("kernel32\GetProcAddress", "Ptr", hOpenGL, "AStr", "glEndList", "Ptr")

GL_COLOR_BUFFER_BIT := 0x00004000
GL_MODELVIEW := 0x1700
GL_PROJECTION := 0x1701
GL_COMPILE := 0x1300
GL_TRIANGLES := 0x0004
GL_QUADS := 0x0007
GL_LINE_LOOP := 0x0002
GL_BLEND := 0x0BE2
GL_SRC_ALPHA := 0x0302
GL_ONE_MINUS_SRC_ALPHA := 0x0303
GL_LINE_SMOOTH := 0x0B20

DllCall("opengl32\glBlendFunc", "UInt", GL_SRC_ALPHA, "UInt", GL_ONE_MINUS_SRC_ALPHA)

NumWKeys := 0, Index := 1
Loop, % NumKeys
	{
	If Index in 1,3,5,7,8,10,12
		NumWKeys++
	Index++
	If Index > 12
		Index := 1
	}
KeyWW := 100/NumWKeys, KeyBW := KeyWW/4*2.5, KeyC := 5
KeyBW2 := KeyBW/2, KeyBW4 := KeyBW/4
List := DllCall(glGenLists, "UInt", 6)
DllCall(glNewList, "UInt", List+0, "UInt", GL_COMPILE)
DllCall(glLoadIdentity)
DllCall(glColor4f, "Float", 0, "Float", 0, "Float", 0, "Float", 1)
DllCall(glBegin, "UInt", GL_LINE_LOOP)
DllCall(glVertex2f, "Float", 0.001, "Float", 0.001)
DllCall(glVertex2f, "Float", 0.001, "Float", 9.999)
DllCall(glVertex2f, "Float", 99.999, "Float", 9.999)
DllCall(glVertex2f, "Float", 99.999, "Float", 0.001)
DllCall(glEnd)
DllCall(glEndList)

DllCall(glNewList, "UInt", List+1, "UInt", GL_COMPILE)
DllCall(glBegin, "UInt", GL_QUADS)
DllCall(glColor4f, "Float", 0.5, "Float", 0.5, "Float", 0.5, "Float", 1)
DllCall(glVertex2f, "Float", 0, "Float", 0)
DllCall(glVertex2f, "Float", KeyWW, "Float", 0)
DllCall(glColor4f, "Float", 1, "Float", 1, "Float", 1, "Float", 1)
DllCall(glVertex2f, "Float", KeyWW, "Float", 1)
DllCall(glVertex2f, "Float", 0, "Float", 1)
DllCall(glVertex2f, "Float", 0, "Float", 1)
DllCall(glVertex2f, "Float", KeyWW, "Float", 1)
DllCall(glVertex2f, "Float", KeyWW, "Float", 9.6)
DllCall(glVertex2f, "Float", 0, "Float", 9.6)
DllCall(glEnd)
DllCall(glColor4f, "Float", 0, "Float", 0, "Float", 0, "Float", 1)
DllCall(glBegin, "UInt", GL_LINE_LOOP)
DllCall(glVertex2f, "Float", 0, "Float", 0)
DllCall(glVertex2f, "Float", KeyWW, "Float", 0)
DllCall(glVertex2f, "Float", KeyWW, "Float", 9.6)
DllCall(glVertex2f, "Float", 0, "Float", 9.6)
DllCall(glEnd)
DllCall(glTranslatef, "Float", KeyWW, "Float", 0, "Float", 0)
DllCall(glEndList)

DllCall(glNewList, "UInt", List+2, "UInt", GL_COMPILE)
DllCall(glTranslatef, "Float", KeyWW, "Float", 0, "Float", 0)
DllCall(glBegin, "UInt", GL_QUADS)
DllCall(glColor4f, "Float", 0.15, "Float", 0.15, "Float", 0.15, "Float", 1)
DllCall(glVertex2f, "Float", -KeyBW2, "Float", 0)
DllCall(glVertex2f, "Float", KeyBW2, "Float", 0)
DllCall(glVertex2f, "Float", KeyBW2, "Float", 10/4*2.5)
DllCall(glVertex2f, "Float", -KeyBW2, "Float", 10/4*2.5)
DllCall(glColor4f, "Float", 0.2, "Float", 0.2, "Float", 0.2, "Float", 1)
DllCall(glVertex2f, "Float", -KeyBW4, "Float", 0.5)
DllCall(glVertex2f, "Float", KeyBW4, "Float", 0.5)
DllCall(glColor4f, "Float", 0.5, "Float", 0.5, "Float", 0.5, "Float", 1)
DllCall(glVertex2f, "Float", KeyBW4, "Float", 10/4*2.0)
DllCall(glVertex2f, "Float", -KeyBW4, "Float", 10/4*2.0)
DllCall(glColor4f, "Float", 0.2, "Float", 0.2, "Float", 0.2, "Float", 1)
DllCall(glVertex2f, "Float", -KeyBW4, "Float", 0.5)
DllCall(glVertex2f, "Float", KeyBW4, "Float", 0.5)
DllCall(glColor4f, "Float", 0.5, "Float", 0.5, "Float", 0.5, "Float", 1)
DllCall(glVertex2f, "Float", KeyBW2, "Float", 0)
DllCall(glVertex2f, "Float", -KeyBW2, "Float", 0)
DllCall(glColor4f, "Float", 0.3, "Float", 0.3, "Float", 0.3, "Float", 1)
DllCall(glVertex2f, "Float", -KeyBW4, "Float", 10/4*2.0)
DllCall(glVertex2f, "Float", KeyBW4, "Float", 10/4*2.0)
DllCall(glColor4f, "Float", 0.2, "Float", 0.2, "Float", 0.2, "Float", 1)
DllCall(glVertex2f, "Float", KeyBW2, "Float", 10/4*2.5)
DllCall(glVertex2f, "Float", -KeyBW2, "Float", 10/4*2.5)
DllCall(glEnd)
DllCall(glEndList)

DllCall(glNewList, "UInt", List+3, "UInt", GL_COMPILE)
DllCall(glBegin, "UInt", GL_QUADS)
DllCall(glColor4f, "Float", 0.4, "Float", 0.4, "Float", 0.4, "Float", 1)
DllCall(glVertex2f, "Float", 0, "Float", 0)
DllCall(glVertex2f, "Float", KeyWW, "Float", 0)
DllCall(glColor4f, "Float", 0.9, "Float", 0.9, "Float", 0.9, "Float", 1)
DllCall(glVertex2f, "Float", KeyWW, "Float", 1.5)
DllCall(glVertex2f, "Float", 0, "Float", 1.5)
DllCall(glVertex2f, "Float", 0, "Float", 1.5)
DllCall(glVertex2f, "Float", KeyWW, "Float", 1.5)
DllCall(glColor4f, "Float", 0.7, "Float", 0.7, "Float", 0.7, "Float", 1)
DllCall(glVertex2f, "Float", KeyWW, "Float", 9.6)
DllCall(glVertex2f, "Float", 0, "Float", 9.6)
DllCall(glVertex2f, "Float", 0, "Float", 9.6)
DllCall(glVertex2f, "Float", KeyWW, "Float", 9.6)
DllCall(glVertex2f, "Float", KeyWW-0.4, "Float", 9.7)
DllCall(glVertex2f, "Float", 0.4, "Float", 9.7)
DllCall(glEnd)
DllCall(glColor4f, "Float", 0, "Float", 0, "Float", 0, "Float", 1)
DllCall(glBegin, "UInt", GL_LINE_LOOP)
DllCall(glVertex2f, "Float", 0, "Float", 0)
DllCall(glVertex2f, "Float", KeyWW, "Float", 0)
DllCall(glVertex2f, "Float", KeyWW, "Float", 9.6)
DllCall(glVertex2f, "Float", KeyWW-0.4, "Float", 9.7)
DllCall(glVertex2f, "Float", 0.4, "Float", 9.7)
DllCall(glVertex2f, "Float", 0, "Float", 9.6)
DllCall(glEnd)
DllCall(glTranslatef, "Float", KeyWW, "Float", 0, "Float", 0)
DllCall(glEndList)

DllCall(glNewList, "UInt", List+4, "UInt", GL_COMPILE)
DllCall(glTranslatef, "Float", KeyWW, "Float", 0, "Float", 0)
DllCall(glBegin, "UInt", GL_QUADS)
DllCall(glColor4f, "Float", 0, "Float", 0, "Float", 0, "Float", 1)
DllCall(glVertex2f, "Float", -KeyBW2, "Float", 0)
DllCall(glVertex2f, "Float", KeyBW2, "Float", 0)
DllCall(glVertex2f, "Float", KeyBW2, "Float", 10/4*2.5)
DllCall(glVertex2f, "Float", -KeyBW2, "Float", 10/4*2.5)
DllCall(glColor4f, "Float", 0.1, "Float", 0.1, "Float", 0.1, "Float", 1)
DllCall(glVertex2f, "Float", -KeyBW4, "Float", 0.5)
DllCall(glVertex2f, "Float", KeyBW4, "Float", 0.5)
DllCall(glColor4f, "Float", 0.25, "Float", 0.25, "Float", 0.25, "Float", 1)
DllCall(glVertex2f, "Float", KeyBW4, "Float", 10/4*2.0)
DllCall(glVertex2f, "Float", -KeyBW4, "Float", 10/4*2.0)
DllCall(glColor4f, "Float", 0.1, "Float", 0.1, "Float", 0.1, "Float", 1)
DllCall(glVertex2f, "Float", -KeyBW4, "Float", 0.5)
DllCall(glVertex2f, "Float", KeyBW4, "Float", 0.5)
DllCall(glColor4f, "Float", 0.25, "Float", 0.25, "Float", 0.25, "Float", 1)
DllCall(glVertex2f, "Float", KeyBW2, "Float", 0)
DllCall(glVertex2f, "Float", -KeyBW2, "Float", 0)
DllCall(glColor4f, "Float", 0.15, "Float", 0.15, "Float", 0.15, "Float", 1)
DllCall(glVertex2f, "Float", -KeyBW4, "Float", 10/4*2.0)
DllCall(glVertex2f, "Float", KeyBW4, "Float", 10/4*2.0)
DllCall(glColor4f, "Float", 0.1, "Float", 0.1, "Float", 0.1, "Float", 1)
DllCall(glVertex2f, "Float", KeyBW2, "Float", 10/4*2.5)
DllCall(glVertex2f, "Float", -KeyBW2, "Float", 10/4*2.5)
DllCall(glEnd)
DllCall(glEndList)

PointSize := 1
DllCall(glNewList, "UInt", List+5, "UInt", GL_COMPILE)
DllCall(glEnable, "UInt", GL_BLEND)
DllCall(glBegin, "UInt", GL_TRIANGLES)
DllCall(glColor4f, "Float", 1, "Float", 0, "Float", 0, "Float", 1)
DllCall(glVertex2f, "Float", 0, "Float", 0)
DllCall(glColor4f, "Float", 1, "Float", 0, "Float", 0, "Float", 0)
DllCall(glVertex2f, "Float", 0, "Float", PointSize)
DllCall(glVertex2f, "Float", Sin(10.0531)*PointSize, "Float", -(Cos(10.0531)*PointSize))
DllCall(glEnd)
DllCall(glDisable, "UInt", GL_BLEND)
DllCall(glEndList)

DllCall(glNewList, "UInt", List+6, "UInt", GL_COMPILE)
DllCall(glTranslatef, "Float", 0, "Float", 8, "Float", 0)
DllCall(glScalef, "Float", 1.2, "Float", 1, "Float", 1)
Loop, 10
	{
	DllCall(glCallList, "UInt", List+5)
	DllCall(glRotatef, "Float", 36, "Float", 0, "Float", 0, "Float", 1)
	}
DllCall(glEndList)
FontOut := DllCall(glGenLists, "UInt", charR)
FontIn := DllCall(glGenLists, "UInt", charR)
hFont := DllCall("gdi32\CreateFont" AW
	, "Int", -1
	, "Int", 0
	, "Int", 0
	, "Int", 0
	, "Int", 800
	, "UInt", 0
	, "UInt", 0
	, "UInt", 0
	, "UInt", 0
	, "UInt", 4
	, "UInt", 0
	, "UInt", 4
	, "UInt", 0
	, "Ptr", 0
	, "Ptr")
hOFont := DllCall("gdi32\SelectObject", "Ptr", hDC, "Ptr", hFont, "Ptr")
VarSetCapacity(gmf, charR*24, 0)	; GLYPHMETRICSFLOAT struct
DllCall("opengl32\wglUseFontOutlines" AW
	, "Ptr", hDC
	, "UInt", charL
	, "UInt", charR
	, "UInt", FontOut
	, "Float", 0
	, "Float", 0.2
	, "Int", 0
	, "Ptr", &gmf)
DllCall("opengl32\wglUseFontOutlines" AW
	, "Ptr", hDC
	, "UInt", charL
	, "UInt", charR
	, "UInt", FontIn
	, "Float", 0
	, "Float", 0.2
	, "Int", 1
	, "Ptr", 0)
Gui, 2:Show, w%KbdW% h%KbdH%, Virtual keyboard
SetTimer, UpdateOpenGL, 50
Return

UpdateOpenGL:
Critical
DllCall(glClear, "UInt", GL_COLOR_BUFFER_BIT)
DllCall(glViewport, "Int", 0, "Int", 0, "Int", KbdW, "Int", KbdH)
DllCall(glMatrixMode, "UInt", GL_PROJECTION)
DllCall(glLoadIdentity)
DllCall(glOrtho, "Double", 0, "Double", 100, "Double", 10, "Double", 0, "Double", -1, "Double", 1)
DllCall(glMatrixMode, "UInt", GL_MODELVIEW)
DllCall(glLoadIdentity)
Index := 1, cOktav := 1
Loop, % NumKeys
	{
	If Index in 1,3,5,7,8,10,12
		{
		DllCall(glCallList, "UInt", ((KeyI%A_Index%down) ? List+3 : List+1))
		VK := GetKeyVK(Format("sc{:x}", MKey%A_Index%))
		If VK between %charL% and %charH%
			{
			DllCall(glPushMatrix)
			DllCall(glTranslatef, "Float", -(KeyWW*0.8), "Float", 9, "Float", 0)
			DllCall(glScalef, "Float", 3, "Float", -3, "Float",  1)
			DllCall(glPushMatrix)
			If (Index = 8 && cOktav = Oktav)
				DllCall(glColor4f, "Float", 1, "Float", 0.5, "Float", 0.5, "Float", 0.5)
			Else DllCall(glColor4f, "Float", 0.7, "Float", 0.7, "Float", 0.7, "Float", 0.5)
			DllCall(glEnable, "UInt", GL_BLEND)
			DllCall(glEnable, "UInt", GL_LINE_SMOOTH)
			DllCall(glCallList, "UInt", FontOut+VK-charL)
			DllCall(glDisable, "UInt", GL_LINE_SMOOTH)
			DllCall(glDisable, "UInt", GL_BLEND)
			DllCall(glPopMatrix)
			If (Index = 8 && cOktav = Oktav)
				DllCall(glColor4f, "Float", 1, "Float", 0.5, "Float", 0.5, "Float", 1)
			Else DllCall(glColor4f, "Float", 0.7, "Float", 0.7, "Float", 0.7, "Float", 1)
			DllCall(glCallList, "UInt", FontIn+VK-charL)
			DllCall(glPopMatrix)
			}
		}
	Index++
	if Index > 12
		{
		Index := 1
		cOktav--
		}
	}
DllCall(glLoadIdentity)
Index := 1
Loop, % NumKeys
	{
	If Index in 2,4,6,9,11
		DllCall(glCallList, "UInt", ((KeyI%A_Index%down) ? List+4 : List+2))
	If Index in 6,11
		DllCall(glTranslatef, "Float", KeyWW, "Float", 0, "Float", 0)
	Index++
	If Index > 12
		Index := 1
	}
;DllCall(glLoadIdentity)
;DllCall(glTranslatef, "Float", KeyWW*4.5, "Float", 0, "Float", 0)
;DllCall(glCallList, "UInt", List+6)
DllCall(SwapBuffers, "Ptr", hDC)
Return

